package juliac.generated;

import java.lang.annotation.Annotation;
import java.util.ArrayList;
import org.objectweb.fractal.julia.control.lifecycle.ChainedIllegalLifeCycleException;
import org.objectweb.fractal.julia.factory.ChainedInstantiationException;
import org.objectweb.fractal.juliac.runtime.ClassLoaderFcItf;
import org.objectweb.fractal.juliac.runtime.ClassLoaderItf;
import java.util.Collection;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.julia.ComponentInterface;
import org.ow2.frascati.tinfi.control.content.ContentClassMetaData;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashMap;
import org.ow2.frascati.tinfi.control.content.IllegalContentClassMetaData;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.ow2.frascati.tinfi.control.intent.IntentHandler;
import org.objectweb.fractal.api.Interface;
import org.ow2.frascati.tinfi.control.intent.InterfaceFilter;
import org.ow2.frascati.tinfi.control.intent.InterfaceMethodFilter;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.juliac.runtime.Juliac;
import org.objectweb.fractal.api.control.LifeCycleController;
import java.util.List;
import java.util.Map;
import org.ow2.frascati.tinfi.metadata.MetaData;
import java.lang.reflect.Method;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.ow2.frascati.tinfi.control.intent.SCABasicIntentController;
import org.ow2.frascati.tinfi.control.intent.SCAIntentController;
import org.ow2.frascati.tinfi.TinfiComponentInterceptor;
import org.ow2.frascati.tinfi.TinfiRuntimeException;
import org.objectweb.fractal.api.Type;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin
 * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin
 * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin
 */
public class SCAPrimitiveIntentControllerImpl implements Controller , Generated , SCABasicIntentController , SCAIntentController {
    /** 
     * Check that the component is stopped and then call the overriden method.
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler)
     */
    public void addFcIntentHandler(IntentHandler handler) throws IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler);
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * Does nothing.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * The {@link LifeCycleController} interface of the component to which this
     * controller object belongs.
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#weaveableOptLC
     */
    public LifeCycleController weaveableOptLC;
    
    /** 
     * Add the specified intent handler on all interfaces (service and
     * reference) of the current component.
     * 
     * @param handler  the intent handler to add
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler)
     */
    private void addFcIntentHandler$0(IntentHandler handler) {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  interceptors = getFcInterceptors();
        Collection<org.ow2.frascati.tinfi.TinfiComponentInterceptor>  tcis = interceptors.values();
        for (TinfiComponentInterceptor tci : tcis) {
            tci.addIntentHandler(handler);
        }
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * Check that the component is stopped and then call the overriden method.
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler,java.lang.Class,java.lang.String)
     */
    public <T extends java.lang.annotation.Annotation> void addFcIntentHandler(IntentHandler handler, Class<T>  annotcl, String value) throws IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler ,annotcl ,value);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptLC = ((LifeCycleController)(ic.getOptionalInterface("lifecycle-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$1(ic);
    }
    
    /** 
     * Check that the component is stopped and then call the overriden method.
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#removeFcHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler)
     */
    public void removeFcHandler(IntentHandler handler) throws IllegalLifeCycleException {
        checkFcStopped();
        removeFcHandler$0(handler);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     *
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        String fcContentDesc = ((String)(ic.content));
        try {
            ContentClassMetaData ccmd = ContentClassMetaData.get(fcContentDesc);
            md = ccmd.getMetaData();
        } catch (IllegalContentClassMetaData e) {
            throw new ChainedInstantiationException(e , weaveableOptC , e.getMessage());
        }
        initFcController$2(ic);
    }
    
    /** 
     * Add the specified intent handler on all interfaces (business or control)
     * which match the specified interface filter.
     * 
     * @param handler  the intent handler to add
     * @param filter   the interface filter
     * @since 0.6
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler,org.ow2.frascati.tinfi.control.intent.InterfaceFilter)
     */
    public void addFcIntentHandler(IntentHandler handler, InterfaceFilter filter) {
        Object[] itfs = weaveableOptC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            boolean accept = filter.accept(itf);
            if (!accept) {
                continue;
            } 
            Object i = ((ComponentInterface)(itf)).getFcItfImpl();
            if (!(i instanceof TinfiComponentInterceptor)) {
                String name = itf.getFcItfName();
                String msg = (("Interface " + name) + " was expected to delegate to an object implementing") + " TinfiComponentInterceptor";
                throw new TinfiRuntimeException(msg);
            } 
            TinfiComponentInterceptor tci = ((TinfiComponentInterceptor)(i));
            tci.addIntentHandler(handler);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin#checkFcStopped()
     */
    private void checkFcStopped() throws IllegalLifeCycleException {
        if ((weaveableOptLC) != null) {
            String state = weaveableOptLC.getFcState();
            if (!(LifeCycleController.STOPPED.equals(state))) {
                throw new ChainedIllegalLifeCycleException(null , weaveableOptC , "The component is not stopped");
            } 
        } 
    }
    
    /** 
     * The {@link Controller#initFcController initFcController} method overriden
     * by this mixin.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     */
    private void initFcController$3(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#md
     */
    private MetaData<?>  md;
    
    private void addFcIntentHandler$1(IntentHandler handler) {
    }
    
    private <T extends java.lang.annotation.Annotation> void addFcIntentHandler$1(IntentHandler handler, Class<T>  annotcl, String value) {
    }
    
    /** 
     * Add the specified intent handler on all pairs interface (business or
     * control), method which match the specified filter.
     * 
     * @param handler  the intent handler to add
     * @param filter   the filter for interface, method pairs
     * @since 0.6
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler,org.ow2.frascati.tinfi.control.intent.InterfaceMethodFilter)
     */
    public void addFcIntentHandler(IntentHandler handler, InterfaceMethodFilter filter) {
        Object[] itfs = weaveableOptC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            Object i = ((ComponentInterface)(itf)).getFcItfImpl();
            if (!(i instanceof TinfiComponentInterceptor)) {
                String name = itf.getFcItfName();
                String msg = (("Interface " + name) + " was expected to delegate to an object implementing") + " TinfiComponentInterceptor";
                throw new TinfiRuntimeException(msg);
            } 
            TinfiComponentInterceptor tci = ((TinfiComponentInterceptor)(i));
            Method[] methods = tci.getMethods();
            for (Method method : methods) {
                boolean accept = filter.accept(itf ,method);
                if (accept) {
                    try {
                        tci.addIntentHandler(handler ,method);
                    } catch (NoSuchMethodException nsme) {
                        throw new TinfiRuntimeException(nsme);
                    }
                } 
            }
        }
    }
    
    private void removeFcHandler$0(IntentHandler handler) {
    }
    
    /** 
     * <p>
     * Add the specified intent handler on all service methods of the current
     * component which satisfy the following conditions:
     * </p>
     * 
     * <ul>
     * <li>the implementation method in the component class is associated with
     *     an annotation of the specified class,</li>
     * <li>the annotation provides a <code>String[] value()</code> method,</li>
     * <li>one of the returned strings when calling <code>value()</code>is equal
     *     to the specified value.</li>
     * </ul>
     * 
     * @param handler  the intent handler to add
     * @param annotcl  the searched for annotation class
     * @param value    the searched for parameter value
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler,java.lang.Class,java.lang.String)
     */
    private <T extends java.lang.annotation.Annotation> void addFcIntentHandler$0(IntentHandler handler, Class<T>  annotcl, String value) {
        List<java.lang.reflect.Method>  methods = getFcMatchingMethods(annotcl ,value);
        for (Method method : methods) {
            TinfiComponentInterceptor tci = getFcInterceptor(method);
            Method m = getFcItfMethod(method);
            try {
                tci.addIntentHandler(handler ,m);
            } catch (NoSuchMethodException e) {
                throw new TinfiRuntimeException(e);
            }
        }
    }
    
    /** 
     * <p>
     * Return the list of methods implemented by the component class which
     * satisfy the following conditions:
     * </p>
     * 
     * <ul>
     * <li>the method is associated with an annotation of the specified class</li>
     * <li>the annotation provides a <code>String[] value()</code> method,</li>
     * <li>one of the returned strings when calling <code>value()</code>is equal
     *     to the specified value.</li>
     * </ul>
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#getFcMatchingMethods(java.lang.Class,java.lang.String)
     */
    private <T extends java.lang.annotation.Annotation> List<java.lang.reflect.Method>  getFcMatchingMethods(Class<T>  annotcl, String value) {
        List<java.lang.reflect.Method>  ret = new ArrayList<java.lang.reflect.Method> ();
        Method[] methods = md.getAllAnnotatedMethods(annotcl);
        for (Method method : methods) {
            T annot = method.getAnnotation(annotcl);
            if (annot == null) {
                List<java.lang.Object>  annots = md.getMetaData(method);
                for (Object o : annots) {
                    Class<?>  ocl = o.getClass();
                    if (annotcl.isAssignableFrom(ocl)) {
                        annot = ((T)(o));
                    } 
                }
            } 
            Class<?>  cl = annot.getClass();
            try {
                Method mvalues = cl.getMethod("value");
                String[] values = null;
                try {
                    values = ((String[])(mvalues.invoke(annot)));
                } catch (Exception e) {
                    throw new TinfiRuntimeException(e);
                }
                for (String v : values) {
                    if (v.equals(value)) {
                        ret.add(method);
                    } 
                }
            } catch (NoSuchMethodException e) {
            }
        }
        return ret;
    }
    
    /** 
     * Add the specified intent handler on the interface (service or reference)
     * whose name is specified.
     * 
     * @param handler  the intent handler to add
     * @param name     the interface name
     * @throws NoSuchInterfaceException  if the interface does not exist
     * @since 0.4.4
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler,java.lang.String)
     */
    public void addFcIntentHandler(IntentHandler handler, String name) throws NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor tci = interceptors.get(name);
        tci.addIntentHandler(handler);
    }
    
    /** 
     * Add the specified intent handler on the method of the service or
     * reference interface whose name is specified.
     * 
     * @param handler  the intent handler to add
     * @param name     the interface name
     * @param method   the method
     * @throws NoSuchInterfaceException  if the interface does not exist
     * @since 0.6
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler,java.lang.String,java.lang.reflect.Method)
     */
    public void addFcIntentHandler(IntentHandler handler, String name, Method method) throws NoSuchMethodException, NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor tci = interceptors.get(name);
        tci.addIntentHandler(handler ,method);
    }
    
    /** 
     * Return the interceptor for the specified component method.
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#getFcInterceptor(java.lang.reflect.Method)
     */
    private TinfiComponentInterceptor getFcInterceptor(Method method) {
        if ((mtcis) == null) {
            initFcMaps();
        } 
        if (!(mtcis.containsKey(method))) {
            String msg = "No interceptor for component method: " + (method.toString());
            throw new TinfiRuntimeException(msg);
        } 
        TinfiComponentInterceptor tci = mtcis.get(method);
        return tci;
    }
    
    /** 
     * Return the list of all intent handlers associated with the interface
     * (service or reference) whose name is specified.
     * 
     * @param name  the interface name
     * @throws NoSuchInterfaceException  if the interface does not exist
     * @since 0.4.4
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#listFcIntentHandler(java.lang.String)
     */
    public List<org.ow2.frascati.tinfi.control.intent.IntentHandler>  listFcIntentHandler(String name) throws NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor tci = interceptors.get(name);
        List<org.ow2.frascati.tinfi.control.intent.IntentHandler>  handlers = tci.listIntentHandler();
        return handlers;
    }
    
    /** 
     * Return the interface method for the specified component method.
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#getFcItfMethod(java.lang.reflect.Method)
     */
    private Method getFcItfMethod(Method method) {
        if ((mms) == null) {
            initFcMaps();
        } 
        if (!(mms.containsKey(method))) {
            String msg = "No interface method for component method: " + (method.toString());
            throw new TinfiRuntimeException(msg);
        } 
        Method m = mms.get(method);
        return m;
    }
    
    /** 
     * Return the list of all intent handlers associated with the method of the
     * interface (service or reference) whose name is specified.
     * 
     * @param name    the interface name
     * @param method  the method
     * @throws NoSuchInterfaceException  if the interface does not exist
     * @throws NoSuchMethodException     if the method does not exist
     * @since 0.6
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#listFcIntentHandler(java.lang.String,java.lang.reflect.Method)
     */
    public List<org.ow2.frascati.tinfi.control.intent.IntentHandler>  listFcIntentHandler(String name, Method method) throws NoSuchMethodException, NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor tci = interceptors.get(name);
        List<org.ow2.frascati.tinfi.control.intent.IntentHandler>  handlers = tci.listIntentHandler(method);
        return handlers;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#mtcis
     */
    private Map<java.lang.reflect.Method, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  mtcis;
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#mms
     */
    private Map<java.lang.reflect.Method, java.lang.reflect.Method>  mms;
    
    /** 
     * Initialize the {@link #mtcis} and {@link #mms} maps.
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#initFcMaps()
     */
    private void initFcMaps() {
        mtcis = new HashMap<java.lang.reflect.Method, org.ow2.frascati.tinfi.TinfiComponentInterceptor> ();
        mms = new HashMap<java.lang.reflect.Method, java.lang.reflect.Method> ();
        Class<?>  compcl = md.getSupportClass();
        Method[] methods = compcl.getMethods();
        Object[] itfs = weaveableOptC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            String name = itf.getFcItfName();
            if ((name.endsWith("-controller")) || (name.equals("component"))) {
                continue;
            } 
            Object i = ((ComponentInterface)(itf)).getFcItfImpl();
            TinfiComponentInterceptor tci = ((TinfiComponentInterceptor)(i));
            InterfaceType it = ((InterfaceType)(itf.getFcItfType()));
            String signature = it.getFcItfSignature();
            Class<?>  business = SCAPrimitiveIntentControllerImpl.loadFcClass(signature);
            Method[] ms = business.getMethods();
            for (Method method : methods) {
                for (Method m : ms) {
                    if (SCAPrimitiveIntentControllerImpl.areSame(m ,method)) {
                        mtcis.put(method ,tci);
                        mms.put(method ,m);
                    } 
                }
            }
        }
    }
    
    /** 
     * Remove the specified intent handler on all interfaces (service and
     * reference) of the current component.
     * 
     * @param handler  the intent handler to remove
     * @since 0.4.4
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#removeFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler)
     */
    public void removeFcIntentHandler(IntentHandler handler) {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  interceptors = getFcInterceptors();
        Collection<org.ow2.frascati.tinfi.TinfiComponentInterceptor>  tcis = interceptors.values();
        for (TinfiComponentInterceptor tci : tcis) {
            tci.removeIntentHandler(handler);
        }
    }
    
    /** 
     * Remove the specified intent handler on the interface (service or
     * reference) whose name is specified.
     * 
     * @param handler  the intent handler to remove
     * @param name     the interface name
     * @throws NoSuchInterfaceException  if the interface does not exist
     * @since 0.4.4
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#removeFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler,java.lang.String)
     */
    public void removeFcIntentHandler(IntentHandler handler, String name) throws NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor tci = interceptors.get(name);
        tci.removeIntentHandler(handler);
    }
    
    /** 
     * Remove the specified intent handler on the method of the interface
     * (service or reference) whose name is specified.
     * 
     * @param handler  the intent handler to remove
     * @param name     the interface name
     * @param method   the method
     * @throws NoSuchInterfaceException  if the interface does not exist
     * @throws NoSuchMethodException     if the method does not exist
     * @since 0.6
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#removeFcIntentHandler(org.ow2.frascati.tinfi.control.intent.IntentHandler,java.lang.String,java.lang.reflect.Method)
     */
    public void removeFcIntentHandler(IntentHandler handler, String name, Method method) throws NoSuchMethodException, NoSuchInterfaceException {
        Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  interceptors = getFcInterceptors();
        if (!(interceptors.containsKey(name))) {
            throw new NoSuchInterfaceException(name);
        } 
        TinfiComponentInterceptor tci = interceptors.get(name);
        tci.removeIntentHandler(handler ,method);
    }
    
    /** 
     * Load, with the Juliac classloadern the class whose name is specified .
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#loadFcClass(java.lang.String)
     */
    private static Class<?>  loadFcClass(String name) {
        Component boot = new Juliac().newFcInstance();
        ClassLoaderItf loader = null;
        try {
            loader = ((ClassLoaderItf)(boot.getFcInterface(ClassLoaderFcItf.NAME)));
        } catch (NoSuchInterfaceException nsie) {
            throw new RuntimeException(nsie);
        }
        try {
            Class<?>  cl = loader.loadClass(name);
            return cl;
        } catch (ClassNotFoundException cnfe) {
            throw new TinfiRuntimeException(cnfe);
        }
    }
    
    /** 
     * Return the interceptors associated with the business interfaces of the
     * current component.
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#getFcInterceptors()
     */
    private Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  getFcInterceptors() {
        if ((interceptors) != null) {
            return interceptors;
        } 
        interceptors = new HashMap<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor> ();
        Object[] itfs = weaveableOptC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            String name = itf.getFcItfName();
            if ((name.endsWith("-controller")) || (name.equals("component"))) {
                continue;
            } 
            Object i = ((ComponentInterface)(itf)).getFcItfImpl();
            if (!(i instanceof TinfiComponentInterceptor)) {
                String msg = (("Interface " + name) + " was expected to delegate to an object implementing") + " TinfiComponentInterceptor";
                throw new TinfiRuntimeException(msg);
            } 
            TinfiComponentInterceptor tci = ((TinfiComponentInterceptor)(i));
            interceptors.put(name ,tci);
        }
        return interceptors;
    }
    
    /** 
     * Return <code>true</code> if the specified methods are the same: same name
     * and same parameters.
     * @see org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin#areSame(java.lang.reflect.Method,java.lang.reflect.Method)
     */
    private static boolean areSame(Method m1, Method m2) {
        String name1 = m1.getName();
        String name2 = m2.getName();
        if (!(name1.equals(name2))) {
            return false;
        } 
        Class<?> [] ptypes1 = m1.getParameterTypes();
        Class<?> [] ptypes2 = m2.getParameterTypes();
        if ((ptypes1.length) != (ptypes2.length)) {
            return false;
        } 
        for (int i = 0 ; i < (ptypes1.length) ; i++) {
            Class<?>  ptype1 = ptypes1[i];
            Class<?>  ptype2 = ptypes2[i];
            if (!(ptype1.equals(ptype2))) {
                return false;
            } 
        }
        return true;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin#interceptors
     */
    private Map<java.lang.String, org.ow2.frascati.tinfi.TinfiComponentInterceptor>  interceptors;
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCAPrimitiveIntentControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.ow2.frascati.tinfi.control.intent.SCAIntentControllerMixin org.ow2.frascati.tinfi.control.intent.SCABasicIntentControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin org.ow2.frascati.tinfi.control.intent.LifeCycleIntentMixin)";
    }
    
}

